## location-service 0.0.1daily13.06.14.1

=== data/CMakeLists.txt ===
# Copyright © 2013 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Thomas Voss <thomas.voss@canonical.com>

configure_file(
  ubuntu-location-service.pc.in ubuntu-location-service.pc @ONLY
)

install(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/ubuntu-location-service.pc
  DESTINATION ${CMAKE_INSTALL_PREFIX}/lib/pkgconfig
)

install(
  FILES ${CMAKE_CURRENT_SOURCE_DIR}/com.ubuntu.location.Service.conf
  DESTINATION /etc/dbus-1/system.d/
)

=== src/location_service/com/ubuntu/location/providers/CMakeLists.txt ===
add_subdirectory(geoclue)
add_subdirectory(gps)
add_subdirectory(skyhook)

set(
  ENABLED_PROVIDER_TARGETS
  ${ENABLED_PROVIDER_TARGETS}
  PARENT_SCOPE
)

set(
  ENABLED_PROVIDER_TARGETS_DEFINITIONS
  ${ENABLED_PROVIDER_TARGETS_DEFINITIONS}
  PARENT_SCOPE
)

=== src/location_service/com/ubuntu/location/providers/geoclue/CMakeLists.txt ===
option(
    LOCATION_SERVICE_ENABLE_GEOCLUE_PROVIDER
    "Enable location provider connecting to existing geoclue providers"
    ON
)

if (LOCATION_SERVICE_ENABLE_GEOCLUE_PROVIDER)

  message(STATUS "Enabling support for Geoclue location providers")

  add_library(geoclue provider.cpp)
  
  set(
    ENABLED_PROVIDER_TARGETS
    ${ENABLED_PROVIDER_TARGETS} geoclue    
    PARENT_SCOPE
  )

  set(
    ENABLED_PROVIDER_TARGETS_DEFINITIONS
    -DCOM_UBUNTU_LOCATION_SERVICE_PROVIDERS_GEOCLUE ${ENABLED_PROVIDER_TARGETS_DEFINITIONS}
    PARENT_SCOPE
  )
endif (LOCATION_SERVICE_ENABLE_GEOCLUE_PROVIDER)

## location-service 0.0.1+13.10.20130709

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

project(ubuntu-location-service)

set(UBUNTU_LOCATION_SERVICE_VERSION_MAJOR 0)
set(UBUNTU_LOCATION_SERVICE_VERSION_MINOR 0)
set(UBUNTU_LOCATION_SERVICE_VERSION_PATCH 1)

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror -Wall -pedantic -Wextra -fPIC -pthread")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -Werror -Wall -fno-strict-aliasing -pedantic -Wextra -fPIC -pthread")

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

include(cmake/EnableCoverageReport.cmake)
include(cmake/FindGFlags.cmake)
include(cmake/FindGLog.cmake)
include(cmake/PrePush.cmake)
include(CTest)

include(GNUInstallDirs)

find_package(PkgConfig)
find_package(Boost 1.49 COMPONENTS system program_options)
find_package(GLog)
pkg_check_modules(DBUS dbus-1)
pkg_check_modules(DBUS_CPP dbus-cpp)

#####################################################################
# Enable code coverage calculation with gcov/gcovr/lcov
# Usage:
#  * Switch build type to coverage (use ccmake or cmake-gui)
#  * Invoke make, make test, make coverage
#  * Find html report in subdir coveragereport
#  * Find xml report feasible for jenkins in coverage.xml
#####################################################################
IF(CMAKE_BUILD_TYPE MATCHES [cC][oO][vV][eE][rR][aA][gG][eE])
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -ftest-coverage -fprofile-arcs" )
  SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -ftest-coverage -fprofile-arcs" )
  SET(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -ftest-coverage -fprofile-arcs" )
  SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -ftest-coverage -fprofile-arcs" )
ENDIF(CMAKE_BUILD_TYPE MATCHES [cC][oO][vV][eE][rR][aA][gG][eE])

option (DISABLE_ERROR_ON_LOCAL_TYPEDEFS_WARNINGS "Disable errors when local typedefs are unused" ON)
if (DISABLE_ERROR_ON_LOCAL_TYPEDEFS_WARNINGS)
	SET (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-error=unused-local-typedefs")
endif (DISABLE_ERROR_ON_LOCAL_TYPEDEFS_WARNINGS)

include_directories(
  ${Boost_INCLUDE_DIRS}
  ${DBUS_INCLUDE_DIRS}
  ${DBUS_CPP_INCLUDE_DIRS}/dbus
  ${GLog_INCLUDE_DIR}
  
  include/location_service
)

add_subdirectory(data)
add_subdirectory(doc)
add_subdirectory(examples)
add_subdirectory(include)
add_subdirectory(src)
add_subdirectory(tests)

# There's no nice way to format this. Thanks CMake.
add_test(LGPL-required
  /bin/sh -c "! grep -rl 'GNU General' ${PROJECT_SOURCE_DIR}/src ${PROJECT_SOURCE_DIR}/include"
)

enable_coverage_report(service)

=== tests/CMakeLists.txt ===
add_subdirectory(/usr/src/gtest gtest)

find_package(Threads)

option(
    LOCATION_SERVICE_ENABLE_DBUS_TEST_RUNNER 
    "Rely on dbus test runner to start a private session for testing purposes" 
    ON
)

if (LOCATION_SERVICE_ENABLE_DBUS_TEST_RUNNER)
    find_program(DBUS_TEST_RUNNER_EXECUTABLE dbus-test-runner)
    message(STATUS "Executing test suite under dbus-test-runner")
endif (LOCATION_SERVICE_ENABLE_DBUS_TEST_RUNNER)

add_executable(
    acceptance_tests
    acceptance_tests.cpp
    test_main.cpp
)

add_executable(
    accuracy_tests
    accuracy_tests.cpp
    test_main.cpp
)

add_executable(
    controller_test
    controller_test.cpp
    test_main.cpp
)

add_executable(
    default_permission_manager_test
    default_permission_manager_test.cpp
    test_main.cpp
)

add_executable(
    engine_test
    engine_test.cpp
    test_main.cpp
)

add_executable(
    position_test
    position_test.cpp
    test_main.cpp
)

add_executable(
    provider_selection_policy_test
    provider_selection_policy_test.cpp
    test_main.cpp
)

add_executable(
    heading_test
    heading_test.cpp
    test_main.cpp
)

add_executable(
    velocity_test
    velocity_test.cpp
    test_main.cpp
)

add_executable(
    wgs84_test
    wgs84_test.cpp
    test_main.cpp
)

add_executable(
    provider_test
    provider_test.cpp
    test_main.cpp
)

add_executable(
    provider_factory_test
    provider_factory_test.cpp
    test_main.cpp
)

target_link_libraries(
    default_permission_manager_test
    
    ubuntu-location-service

    ${CMAKE_THREAD_LIBS_INIT}
    ${Boost_LIBRARIES}
    ${DBUS_LIBRARIES}
    
    gtest
)

target_link_libraries(
    engine_test

    ubuntu-location-service

    ${CMAKE_THREAD_LIBS_INIT}
    ${Boost_LIBRARIES}
    ${DBUS_LIBRARIES}
    
    gmock
    gtest
)

target_link_libraries(
    position_test

    ubuntu-location-service
    
    ${CMAKE_THREAD_LIBS_INIT}
    ${Boost_LIBRARIES}
    ${DBUS_LIBRARIES}
    
    gtest
)

target_link_libraries(
    provider_selection_policy_test

    ubuntu-location-service
    
    ${CMAKE_THREAD_LIBS_INIT}
    ${Boost_LIBRARIES}
    ${DBUS_LIBRARIES}
    
    gmock
    gtest
)

target_link_libraries(
    heading_test
    
    ubuntu-location-service

    ${CMAKE_THREAD_LIBS_INIT}
    ${Boost_LIBRARIES}
    ${DBUS_LIBRARIES}
    
    gtest
)

target_link_libraries(
    velocity_test

    ubuntu-location-service

    ${CMAKE_THREAD_LIBS_INIT}
    ${Boost_LIBRARIES}
    ${DBUS_LIBRARIES}
    
    gtest
)

target_link_libraries(
    wgs84_test

    ubuntu-location-service

    ${CMAKE_THREAD_LIBS_INIT}
    ${Boost_LIBRARIES}
    ${DBUS_LIBRARIES}
    
    gtest
)

target_link_libraries(
    provider_test

    ubuntu-location-service

    ${CMAKE_THREAD_LIBS_INIT}
    ${Boost_LIBRARIES}
    ${DBUS_LIBRARIES}
    
    gmock
    gtest
)

target_link_libraries(
    provider_factory_test

    ubuntu-location-service

    ${CMAKE_THREAD_LIBS_INIT}
    ${Boost_LIBRARIES}
    ${DBUS_LIBRARIES}
    
    gmock
    gtest
)

target_link_libraries(
    acceptance_tests

    ubuntu-location-service

    ${CMAKE_THREAD_LIBS_INIT}
    ${Boost_LIBRARIES}
    ${DBUS_LIBRARIES}
    gtest
)

target_link_libraries(
    accuracy_tests

    ubuntu-location-service

    ${CMAKE_THREAD_LIBS_INIT}
    ${Boost_LIBRARIES}
    ${DBUS_LIBRARIES}
    gtest
)

target_link_libraries(
    controller_test

    ubuntu-location-service

    ${CMAKE_THREAD_LIBS_INIT}
    ${Boost_LIBRARIES}
    ${DBUS_LIBRARIES}

    gmock
    gtest
)

if (LOCATION_SERVICE_ENABLE_GPS_PROVIDERS)
  add_executable(gps_provider_test gps_provider_test.cpp)
  target_link_libraries(
    gps_provider_test

    ubuntu-location-service

    ${CMAKE_THREAD_LIBS_INIT}
    ${Boost_LIBRARIES}
    ${DBUS_LIBRARIES}
    ubuntu_application_api
    gtest
    gtest_main
  )
  add_test(gps_provider_test gps_provider_test)
endif(LOCATION_SERVICE_ENABLE_GPS_PROVIDERS)

if (LOCATION_SERVICE_ENABLE_GEOCLUE_PROVIDERS)
  add_executable(geoclue_provider_test geoclue_provider_test.cpp)
  target_link_libraries(
    geoclue_provider_test
    
    ubuntu-location-service

    ${CMAKE_THREAD_LIBS_INIT}
    ${Boost_LIBRARIES}
    ${DBUS_LIBRARIES}
    gtest
    gtest_main
  )
  if (LOCATION_SERVICE_ENABLE_DBUS_TEST_RUNNER)
    add_test(geoclue_provider_test ${DBUS_TEST_RUNNER_EXECUTABLE} --task=${CMAKE_CURRENT_BINARY_DIR}/geoclue_provider_test)
  else (LOCATION_SERVICE_ENABLE_DBUS_TEST_RUNNER)
    add_test(geoclue_provider_test ${CMAKE_CURRENT_BINARY_DIR}/geoclue_provider_test)
  endif (LOCATION_SERVICE_ENABLE_DBUS_TEST_RUNNER)
endif (LOCATION_SERVICE_ENABLE_GEOCLUE_PROVIDERS)

if (LOCATION_SERVICE_ENABLE_DBUS_TEST_RUNNER)
  add_test(acceptance_tests ${DBUS_TEST_RUNNER_EXECUTABLE} --task=${CMAKE_CURRENT_BINARY_DIR}/acceptance_tests)
else (LOCATION_SERVICE_ENABLE_DBUS_TEST_RUNNER)
  add_test(acceptance_tests ${CMAKE_CURRENT_BINARY_DIR}/acceptance_tests)
endif (LOCATION_SERVICE_ENABLE_DBUS_TEST_RUNNER)

add_test(provider_test provider_test)
add_test(accuracy_tests accuracy_tests)
add_test(controller_test controller_test)
add_test(default_permission_manager_test default_permission_manager_test)
add_test(engine_test engine_test)
add_test(position_test position_test)
add_test(provider_factory_test provider_factory_test)
add_test(provider_selection_policy_test provider_selection_policy_test)
add_test(heading_test heading_test)
add_test(velocity_test velocity_test)
add_test(wgs84_test wgs84_test)

=== examples/service/CMakeLists.txt ===
find_package(PkgConfig)
find_package(Boost COMPONENTS system)
find_package(Threads)

pkg_check_modules(DBUS dbus-1)
pkg_check_modules(DBUS_CPP dbus-cpp)
include_directories(
    ${Boost_INCLUDE_DIRS}    
    ${DBUS_INCLUDE_DIRS}
    ${DBUS_CPP_INCLUDE_DIRS}/dbus

)

link_directories(
  /tmp/wpsapi-4.7.6_05-linux-x86_64/lib
)

add_executable(
    client
    client.cpp
)

add_executable(
    service
    service.cpp
)

target_link_libraries(
    client

    ubuntu-location-service

    ${CMAKE_THREAD_LIBS_INIT}
    ${Boost_LIBRARIES}
    ${DBUS_LIBRARIES}    
)

target_link_libraries(
    service

    ubuntu-location-service

    ${CMAKE_THREAD_LIBS_INIT}
    ${Boost_LIBRARIES}
    ${DBUS_LIBRARIES}
)

add_custom_command(
    OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/ubuntu-location-service.1"
    COMMAND ronn --roff --pipe --organization=ubuntu ${CMAKE_CURRENT_SOURCE_DIR}/service.1.ronn > ${CMAKE_CURRENT_BINARY_DIR}/ubuntu-location-service.1
)

add_custom_target(
    ubuntu-location-service-man-page ALL
    DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/ubuntu-location-service.1"
)

install(
    TARGETS service client
    DESTINATION ${CMAKE_INSTALL_LIBEXECDIR}/examples/
)

install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/ubuntu-location-service.1
    DESTINATION share/doc/${CMAKE_PROJECT_NAME}/man
)

=== src/location_service/com/ubuntu/location/providers/gps/CMakeLists.txt ===
option(
    LOCATION_SERVICE_ENABLE_GPS_PROVIDER
    "Enable location providers relying on the Android HAL to connect to GPS HW"
    ON
)

if (LOCATION_SERVICE_ENABLE_GPS_PROVIDER)
  find_file(
    UBUNTU_APPLICATION_GPS_H ubuntu_application_gps.h
    NAMES ubuntu/application/ubuntu_application_gps.h
  )

  if (UBUNTU_APPLICATION_GPS_H)
    message(STATUS "Enabling GPS location provider")

    add_library(gps provider.cpp)

    target_link_libraries(gps ubuntu_application_api)
  
    set(
      ENABLED_PROVIDER_TARGETS
      ${ENABLED_PROVIDER_TARGETS} gps
      PARENT_SCOPE)

    set(
      ENABLED_PROVIDER_TARGETS_DEFINITIONS
      -DCOM_UBUNTU_LOCATION_SERVICE_PROVIDERS_GPS ${ENABLED_PROVIDER_TARGETS_DEFINITIONS}
      PARENT_SCOPE
    )
  endif (UBUNTU_APPLICATION_GPS_H)
endif (LOCATION_SERVICE_ENABLE_GPS_PROVIDER)

## location-service 0.0.1+13.10.20130819

=== CMakeLists.txt ===
--- 
+++ 
@@ -22,8 +22,8 @@
 find_package(PkgConfig)
 find_package(Boost 1.49 COMPONENTS system program_options)
 find_package(GLog)
-pkg_check_modules(DBUS dbus-1)
-pkg_check_modules(DBUS_CPP dbus-cpp)
+pkg_check_modules(DBUS dbus-1 REQUIRED)
+pkg_check_modules(DBUS_CPP dbus-cpp REQUIRED)
 
 #####################################################################
 # Enable code coverage calculation with gcov/gcovr/lcov

## location-service 0.0.1+13.10.20130821

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,8 +6,8 @@
 set(UBUNTU_LOCATION_SERVICE_VERSION_MINOR 0)
 set(UBUNTU_LOCATION_SERVICE_VERSION_PATCH 1)
 
-set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror -Wall -pedantic -Wextra -fPIC -pthread")
-set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -Werror -Wall -fno-strict-aliasing -pedantic -Wextra -fPIC -pthread")
+set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -pedantic -Wextra -fPIC -pthread")
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -Wall -fno-strict-aliasing -pedantic -Wextra -fPIC -pthread")
 
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

=== include/CMakeLists.txt ===
install(
	DIRECTORY location_service/com
	DESTINATION include/ubuntu-location-service-${UBUNTU_LOCATION_SERVICE_VERSION_MAJOR}
)

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,3 @@
-add_subdirectory(/usr/src/gtest gtest)
-
 find_package(Threads)
 
 option(
@@ -12,6 +10,17 @@
     find_program(DBUS_TEST_RUNNER_EXECUTABLE dbus-test-runner)
     message(STATUS "Executing test suite under dbus-test-runner")
 endif (LOCATION_SERVICE_ENABLE_DBUS_TEST_RUNNER)
+
+# Build with system gmock and embedded gtest
+set (GMOCK_INCLUDE_DIR "/usr/include/gmock/include" CACHE PATH "gmock source include directory")
+set (GMOCK_SOURCE_DIR "/usr/src/gmock" CACHE PATH "gmock source directory")
+set (GTEST_INCLUDE_DIR "${GMOCK_SOURCE_DIR}/gtest/include" CACHE PATH "gtest source include directory")
+
+add_subdirectory(${GMOCK_SOURCE_DIR} "${CMAKE_CURRENT_BINARY_DIR}/gmock")
+include_directories (
+  ${GMOCK_INCLUDE_DIR}
+  ${GTEST_INCLUDE_DIR}
+)
 
 add_executable(
     acceptance_tests

=== examples/service/CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 pkg_check_modules(DBUS dbus-1)
 pkg_check_modules(DBUS_CPP dbus-cpp)
 include_directories(
-    ${Boost_INCLUDE_DIRS}    
+    ${Boost_INCLUDE_DIRS}
     ${DBUS_INCLUDE_DIRS}
     ${DBUS_CPP_INCLUDE_DIRS}/dbus
 
@@ -32,7 +32,7 @@
 
     ${CMAKE_THREAD_LIBS_INIT}
     ${Boost_LIBRARIES}
-    ${DBUS_LIBRARIES}    
+    ${DBUS_LIBRARIES}
 )
 
 target_link_libraries(

=== src/location_service/com/ubuntu/location/CMakeLists.txt ===
add_subdirectory(providers)

add_library(
  ubuntu-location-service SHARED

  default_provider_selection_policy.cpp
  
  engine.cpp
  init_and_shutdown.cpp
  position.cpp
  provider.cpp
  provider_factory.cpp
  proxy_provider.cpp

  service/default_configuration.cpp
  service/default_permission_manager.cpp
  service/implementation.cpp
  service/skeleton.cpp
  service/stub.cpp

  service/session/implementation.cpp
  service/session/interface.cpp
  service/session/skeleton.cpp
  service/session/stub.cpp

  providers/config.cpp
)

set_target_properties(
  ubuntu-location-service

  PROPERTIES
  VERSION ${UBUNTU_LOCATION_SERVICE_VERSION_MAJOR}.${UBUNTU_LOCATION_SERVICE_VERSION_MINOR}.${UBUNTU_LOCATION_SERVICE_VERSION_PATCH}
  SOVERSION ${UBUNTU_LOCATION_SERVICE_VERSION_MAJOR}
)

add_definitions(${ENABLED_PROVIDER_TARGETS_DEFINITIONS})

target_link_libraries(
  ubuntu-location-service

  ${ENABLED_PROVIDER_TARGETS}

  ${Boost_LIBRARIES}
  ${DBUS_LIBRARIES}
  ${GLog_LIBRARY}
)

install(
  TARGETS ubuntu-location-service
  DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

## location-service 0.0.2+13.10.20131016.1

=== examples/service/CMakeLists.txt ===
--- 
+++ 
@@ -51,8 +51,8 @@
 )
 
 add_custom_target(
-    ubuntu-location-service-man-page ALL
-    DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/ubuntu-location-service.1"
+    ubuntu-location-service-man-page
+    DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/ubuntu-location-service.1"
 )
 
 install(
@@ -61,6 +61,6 @@
 )
 
 install(
-    FILES ${CMAKE_CURRENT_BINARY_DIR}/ubuntu-location-service.1
+    FILES ${CMAKE_CURRENT_SOURCE_DIR}/ubuntu-location-service.1
     DESTINATION share/doc/${CMAKE_PROJECT_NAME}/man
 )

=== src/location_service/com/ubuntu/location/CMakeLists.txt ===
--- 
+++ 
@@ -44,9 +44,35 @@
   ${Boost_LIBRARIES}
   ${DBUS_LIBRARIES}
   ${GLog_LIBRARY}
+  ${GFlags_LIBRARY}
 )
 
 install(
   TARGETS ubuntu-location-service
   DESTINATION ${CMAKE_INSTALL_LIBDIR}
 )
+
+add_executable(
+  ubuntu-location-serviced
+
+  service/main.cpp
+)
+
+target_link_libraries(
+  ubuntu-location-serviced
+
+  ubuntu-location-service
+
+  ${ENABLED_PROVIDER_TARGETS}
+
+  ${Boost_LIBRARIES}
+  ${DBUS_LIBRARIES}
+  ${GLog_LIBRARY}
+  ${GFlags_LIBRARY}
+)
+
+install(
+  TARGETS ubuntu-location-serviced
+  DESTINATION ${CMAKE_INSTALL_BINDIR}
+)
+

## location-service 0.0.2+14.04.20140307

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 
 set(UBUNTU_LOCATION_SERVICE_VERSION_MAJOR 0)
 set(UBUNTU_LOCATION_SERVICE_VERSION_MINOR 0)
-set(UBUNTU_LOCATION_SERVICE_VERSION_PATCH 1)
+set(UBUNTU_LOCATION_SERVICE_VERSION_PATCH 2)
 
 set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -pedantic -Wextra -fPIC -pthread")
 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -Wall -fno-strict-aliasing -pedantic -Wextra -fPIC -pthread")
@@ -22,6 +22,7 @@
 find_package(PkgConfig)
 find_package(Boost 1.49 COMPONENTS system program_options)
 find_package(GLog)
+find_package(GFlags)
 pkg_check_modules(DBUS dbus-1 REQUIRED)
 pkg_check_modules(DBUS_CPP dbus-cpp REQUIRED)
 
@@ -50,7 +51,7 @@
   ${DBUS_INCLUDE_DIRS}
   ${DBUS_CPP_INCLUDE_DIRS}/dbus
   ${GLog_INCLUDE_DIR}
-  
+  ${GFlags_INCLUDE_DIR}
   include/location_service
 )

=== data/CMakeLists.txt ===
--- 
+++ 
@@ -18,6 +18,10 @@
   ubuntu-location-service.pc.in ubuntu-location-service.pc @ONLY
 )
 
+configure_file(
+  ubuntu-location-service.conf.in ubuntu-location-service.conf @ONLY
+)
+
 install(
   FILES ${CMAKE_CURRENT_BINARY_DIR}/ubuntu-location-service.pc
   DESTINATION ${CMAKE_INSTALL_PREFIX}/lib/pkgconfig
@@ -27,3 +31,8 @@
   FILES ${CMAKE_CURRENT_SOURCE_DIR}/com.ubuntu.location.Service.conf
   DESTINATION /etc/dbus-1/system.d/
 )
+
+install(
+  FILES ${CMAKE_CURRENT_BINARY_DIR}/ubuntu-location-service.conf
+  DESTINATION /etc/init/
+)

=== examples/CMakeLists.txt ===
add_subdirectory(service)

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -18,6 +18,8 @@
 
 add_subdirectory(${GMOCK_SOURCE_DIR} "${CMAKE_CURRENT_BINARY_DIR}/gmock")
 include_directories (
+  ${CMAKE_SOURCE_DIR}/src/location_service
+
   ${GMOCK_INCLUDE_DIR}
   ${GTEST_INCLUDE_DIR}
 )
@@ -47,6 +49,12 @@
 )
 
 add_executable(
+    dummy_provider_tests
+    dummy_provider_tests.cpp
+    test_main.cpp
+)
+
+add_executable(
     engine_test
     engine_test.cpp
     test_main.cpp
@@ -103,6 +111,18 @@
     ${Boost_LIBRARIES}
     ${DBUS_LIBRARIES}
     
+    gtest
+)
+
+target_link_libraries(
+    dummy_provider_tests
+
+    ubuntu-location-service
+
+    ${CMAKE_THREAD_LIBS_INIT}
+    ${Boost_LIBRARIES}
+    ${DBUS_LIBRARIES}
+
     gtest
 )
 
@@ -295,3 +315,4 @@
 add_test(heading_test heading_test)
 add_test(velocity_test velocity_test)
 add_test(wgs84_test wgs84_test)
+add_test(dummy_provider_tests dummy_provider_tests)

=== examples/service/CMakeLists.txt ===
--- 
+++ 
@@ -33,6 +33,7 @@
     ${CMAKE_THREAD_LIBS_INIT}
     ${Boost_LIBRARIES}
     ${DBUS_LIBRARIES}
+    ${DBUS_CPP_LDFLAGS}
 )
 
 target_link_libraries(
@@ -43,6 +44,7 @@
     ${CMAKE_THREAD_LIBS_INIT}
     ${Boost_LIBRARIES}
     ${DBUS_LIBRARIES}
+    ${DBUS_CPP_LDFLAGS}
 )
 
 add_custom_command(

=== src/location_service/com/ubuntu/location/CMakeLists.txt ===
--- 
+++ 
@@ -43,6 +43,7 @@
 
   ${Boost_LIBRARIES}
   ${DBUS_LIBRARIES}
+  ${DBUS_CPP_LDFLAGS}
   ${GLog_LIBRARY}
   ${GFlags_LIBRARY}
 )

=== src/location_service/com/ubuntu/location/providers/CMakeLists.txt ===
--- 
+++ 
@@ -1,3 +1,4 @@
+add_subdirectory(dummy)
 add_subdirectory(geoclue)
 add_subdirectory(gps)
 add_subdirectory(skyhook)

=== src/location_service/com/ubuntu/location/providers/dummy/CMakeLists.txt ===
add_library(
  dummy
  
  provider.h
  provider.cpp)

set(
  ENABLED_PROVIDER_TARGETS
  ${ENABLED_PROVIDER_TARGETS} dummy
  PARENT_SCOPE)

=== src/location_service/com/ubuntu/location/providers/gps/CMakeLists.txt ===
option(
    LOCATION_SERVICE_ENABLE_GPS_PROVIDER
    "Enable location providers relying on the Android HAL to connect to GPS HW"
    ON
)

if (LOCATION_SERVICE_ENABLE_GPS_PROVIDER)
  find_file(
    UBUNTU_HARDWARE_GPS_H gps.h
    NAMES ubuntu/hardware/gps.h
  )

  if (UBUNTU_HARDWARE_GPS_H)
    message(STATUS "Enabling GPS location provider")

    add_library(gps provider.cpp)

    target_link_libraries(gps ubuntu_platform_hardware_api.so)
  
    set(
      ENABLED_PROVIDER_TARGETS
      ${ENABLED_PROVIDER_TARGETS} gps
      PARENT_SCOPE)

    set(
      ENABLED_PROVIDER_TARGETS_DEFINITIONS
      -DCOM_UBUNTU_LOCATION_SERVICE_PROVIDERS_GPS ${ENABLED_PROVIDER_TARGETS_DEFINITIONS}
      PARENT_SCOPE
    )
  endif (UBUNTU_HARDWARE_GPS_H)
endif (LOCATION_SERVICE_ENABLE_GPS_PROVIDER)

=== src/location_service/com/ubuntu/location/providers/skyhook/CMakeLists.txt ===
option(
    LOCATION_SERVICE_ENABLE_SKYHOOK_PROVIDER
    "Enable location provider relying on the Skyhook SDK"
    ON
)

if (LOCATION_SERVICE_ENABLE_SKYHOOK_PROVIDER)

  pkg_check_modules(WPSAPI wpsapi)

  if (WPSAPI_FOUND)
    message(STATUS "Enabling support for Skyhook location providers")
    
    add_definitions(-DCOM_UBUNTU_LOCATION_SERVICE_PROVIDERS_SKYHOOK)

    include_directories(${WPSAPI_INCLUDE_DIRS})
    link_directories(${WPSAPI_LIBRARY_DIRS})

    add_library(skyhook provider.cpp)
  
    target_link_libraries(
      skyhook 

      ${WPSAPI_LIBRARIES}
      iw
    )

    set(
      ENABLED_PROVIDER_TARGETS
      skyhook ${ENABLED_PROVIDER_TARGETS}
      PARENT_SCOPE
    )

    set(
      ENABLED_PROVIDER_TARGETS_DEFINITIONS
      -DCOM_UBUNTU_LOCATION_SERVICE_PROVIDERS_SKYHOOK ${ENABLED_PROVIDER_TARGETS_DEFINITIONS}
      PARENT_SCOPE
    )
  endif (WPSAPI_FOUND)
endif (LOCATION_SERVICE_ENABLE_SKYHOOK_PROVIDER)

## location-service 2.1+14.10.20141014

=== debian/changelog ===
location-service (2.1+14.10.20141014-0ubuntu1) utopic; urgency=low

  [ thomas-voss ]
  * Switch to a NonSelectingProviderSelectionPolicy by default.

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Tue, 14 Oct 2014 12:44:53 +0000

location-service (2.1+14.10.20141013-0ubuntu1) utopic; urgency=low

  [ thomas-voss ]
  * Allow for creation of initially invalid radio cells. (LP: #1380668)

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Mon, 13 Oct 2014 15:28:59 +0000

location-service (2.1+14.10.20141010-0ubuntu1) utopic; urgency=low

  [ thomas-voss ]
  * Prefer /system/etc/gps.conf over /etc/gps.conf.

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Fri, 10 Oct 2014 07:18:05 +0000

location-service (2.1+14.10.20141009.1-0ubuntu1) utopic; urgency=low

  [ thomas-voss ]
  * Make sure that modems are cached, no matter if they come with a
    valid NetworkRegistration.

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Thu, 09 Oct 2014 15:18:56 +0000

location-service (2.1+14.10.20141008-0ubuntu1) utopic; urgency=low

  [ thomas-voss ]
  * Make the service translateable. (LP: #1354092)

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Wed, 08 Oct 2014 09:20:31 +0000

location-service (2.1+14.10.20141006-0ubuntu1) utopic; urgency=low

  [ Alberto Aguirre ]
  * Ensure Engine::for_each_provider fulfills the noexcept promise

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Mon, 06 Oct 2014 16:39:42 +0000

location-service (2.1+14.10.20140925.2-0ubuntu1) utopic; urgency=low

  [ thomas-voss ]
  * Implement heuristic to invalidate 3G cells after 60 seconds. (LP:
    #1371514)

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Thu, 25 Sep 2014 20:27:06 +0000

location-service (2.1+14.10.20140917.1-0ubuntu1) utopic; urgency=low

  [ thomas-voss ]
  * Expose remote::Interface and respective stub/skeleton for using and
    exposing remote location providers.
  * Add a standalone daemon for executing providers out of process.

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Wed, 17 Sep 2014 13:27:53 +0000

location-service (2.1+14.10.20140915-0ubuntu1) utopic; urgency=low

  [ Loïc Minier ]
  * Update upstart job start conditions; workaround startup issue with a
    sleep. (LP: #1356468)

  [ thomas-voss ]
  * Somewhat clean up remote provider and add an acceptance-style test.

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Mon, 15 Sep 2014 20:02:59 +0000

location-service (2.1+14.10.20140829-0ubuntu1) utopic; urgency=medium

  [ Manuel de la Pena ]
  * Add a new provider for the remote project.

  [ Manuel de la Peña ]
  * Improve the accuracy reported by the remote provider.

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Fri, 29 Aug 2014 11:01:26 +0000

location-service (2.0.1+14.10.20140825-0ubuntu1) utopic; urgency=low

  [ thomas-voss ]
  * Add request for wireless scans to load test threads. Make sure that
    cached devices are considered instead of recreating device
    instances. Make sure that scan done signals are relayed correctly.

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Mon, 25 Aug 2014 09:14:46 +0000

location-service (2.0.1+14.10.20140818-0ubuntu1) utopic; urgency=low

  [ thomas-voss ]
  * Add a demultiplexing reporter implementation. Adjust daemon config
    to instantiate a demultiplexing reporter instance, together with two
    ichnaea reporters feeding to Mozilla's and Ubuntu's location service
    instances.
  * Make sure the per-user trust-store instances are restarted on
    location service restarts.
  * Clean up CachedRadioCell and CachedWirelessNetwork. Switch to
    logging to syslog. (LP: #1356814)
  * Map edge -> gsm. Map hspa -> umts. (LP: #1357042)

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Mon, 18 Aug 2014 08:11:55 +0000

location-service (2.0.1+14.10.20140811-0ubuntu1) utopic; urgency=low

  [ thomas-voss ]
  * Make sure that state property changes are correctly reported to the
    bus. (LP: #1348334)

  [ Ubuntu daily release ]
  * New rebuild forced

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Mon, 11 Aug 2014 10:21:20 +0000

location-service (2.0.1+14.10.20140808.1-0ubuntu1) utopic; urgency=low

  [ thomas-voss ]
  * Ensure that connections to events are properly cut on destruction.
  * Adjust naming of properties as exposed by NetworkManager.

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Fri, 08 Aug 2014 19:25:54 +0000

location-service (2.0.1+14.10.20140808-0ubuntu1) utopic; urgency=low

  [ Nick Dedekind ]
  * Revert hotfix for bug#1352977 (LP: #1352977)

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Fri, 08 Aug 2014 09:12:14 +0000

location-service (2.0.1+14.10.20140807.1-0ubuntu1) utopic; urgency=low

  [ thomas-voss ]
  * Add camera app and osm touch to the whitelist for permission mgmt.

  [ Ubuntu daily release ]
  * New rebuild forced

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Thu, 07 Aug 2014 20:45:31 +0000

location-service (2.0.1+14.10.20140806-0ubuntu1) utopic; urgency=low

  [ thomas-voss ]
  * Make the location service a trusted helper.

  [ Ubuntu daily release ]
  * New rebuild forced

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Wed, 06 Aug 2014 14:26:22 +0000

location-service (2.0.1+14.10.20140731-0ubuntu1) utopic; urgency=low

  [ thomas-voss ]
  * Expose connectivity state and primary connection characteristics.
    (LP: #1337102)

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Thu, 31 Jul 2014 13:25:55 +0000

location-service (2.0.1+14.10.20140730.1-0ubuntu1) utopic; urgency=low

  [ thomas-voss ]
  * Make sure that logging directories are created on service startup.
    (LP: #1349704)
  * Fix build warnings.
  * Add a vanilla gps.conf file and install it to /etc/gps.conf. Make
    sure that expections thrown while trying to download GPS Xtra data
    do not abort the service. (LP: #1347887)



=== debian/control ===
Source: location-service
Section: utils
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Thomas Voß <thomas.voss@canonical.com>
Build-Depends: cmake,
               curl,
               libdbus-cpp-dev (>= 4.0.0),
               debhelper (>= 9),
               doxygen,
               geoclue-ubuntu-geoip,
               google-mock (>= 1.6.0+svn437),
               graphviz,
# We rely on C++11 features, and to prevent from ABI breaks
# in libstdc++ causing us issues, we explicitly select a G++
# version.
               g++-4.9,
               libapparmor-dev,
               libboost-filesystem-dev,
               libboost-program-options-dev,
               libboost-system-dev,
               libdbus-1-dev,
               libdbus-cpp-dev,
               libgoogle-glog-dev,
               libgtest-dev,
               libiw-dev,
               libjson-c-dev,
               libnet-cpp-dev,
               libprocess-cpp-dev,
               libtrust-store-dev,
               libubuntu-platform-hardware-api-headers [!arm64 !ppc64el !powerpc],
               libubuntu-platform-hardware-api-dev [!arm64 !ppc64el !powerpc],
               libproperties-cpp-dev,
               trust-store-bin,
Standards-Version: 3.9.4
Homepage: http://launchpad.net/location-service
# If you aren't a member of ~phablet-team but need to upload packaging changes,
# just go ahead.  ~phablet-team will notice and sync up the code again.
Vcs-Bzr: https://code.launchpad.net/~phablet-team/location-service/trunk
Vcs-Browser: http://bazaar.launchpad.net/~phablet-team/location-service/trunk/files

Package: libubuntu-location-service2
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: location service aggregating position/velocity/heading
 updates and exporting them over dbus.
 .
 Contains the shared library needed by client applications.

Package: libubuntu-location-service-dev
Section: libdevel
Architecture: any
Multi-Arch: foreign
Recommends: ubuntu-location-service-doc,
Depends: libubuntu-location-service2 (= ${binary:Version}),
         libdbus-1-dev,
         libdbus-cpp-dev,
         ${misc:Depends},
Suggests: ubuntu-location-service-doc,
Description: location service aggregating position/velocity/heading
 updates and exporting them over dbus.
 .
 Contains header files required to develop clients talking to the ubuntu
 location service.

Package: libubuntu-location-service-dbg
Section: debug
Architecture: any
Multi-Arch: foreign
Depends: libubuntu-location-service2 (= ${binary:Version}),
         ${misc:Depends},
Description: location service aggregating position/velocity/heading
 updates and exporting them over dbus.
 .
 Contains debug symbols.

Package: ubuntu-location-service-tests
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: location service aggregating position/velocity/heading
 updates and exporting them over dbus.
 .
 Contains all test executables

Package: ubuntu-location-service-bin
Architecture: any
Depends: libubuntu-location-service2 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
         trust-store-bin,
Breaks: ubuntu-location-service-examples (<< 0.0.2),
Replaces: ubuntu-location-service-examples (<< 0.0.2),
Description: location service aggregating position/velocity/heading
 updates and exporting them over dbus.
 .
 Contains the service executable and man pages.

Package: ubuntu-location-service-examples
Architecture: any
Multi-Arch: same
Depends: libubuntu-location-service2 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
         ubuntu-location-service-doc,
Description: location service aggregating position/velocity/heading
 updates and exporting them over dbus.
 .
 Contains example service and client.

Package: ubuntu-location-service-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
         ${shlibs:Depends},
Recommends: ubuntu-location-service-examples,
Description: location service aggregating position/velocity/heading
 updates and exporting them over dbus.
 .
 Contains documentation for service and client.

## location-service 2.1+15.04.20141110.1

=== tests/CMakeLists.txt ===
find_package(Threads)

add_definitions(-DCORE_DBUS_ENABLE_GOOGLE_TEST_FIXTURE -DBOOST_ASIO_DISABLE_MOVE)

option(
    LOCATION_SERVICE_ENABLE_DBUS_TEST_RUNNER 
    "Rely on dbus test runner to start a private session for testing purposes" 
    ON
)

if (LOCATION_SERVICE_ENABLE_DBUS_TEST_RUNNER)
    find_program(DBUS_TEST_RUNNER_EXECUTABLE dbus-test-runner)
    message(STATUS "Executing test suite under dbus-test-runner")
endif (LOCATION_SERVICE_ENABLE_DBUS_TEST_RUNNER)

# Build mongoose as static library to leverage in location reporter testing
add_library(mongoose mongoose.c)
# Explicitly select c99 when compiling mongoose
set_target_properties(
    mongoose
    PROPERTIES COMPILE_FLAGS "-std=c99")

# Build with system gmock and embedded gtest
set (GMOCK_INCLUDE_DIR "/usr/include/gmock/include" CACHE PATH "gmock source include directory")
set (GMOCK_SOURCE_DIR "/usr/src/gmock" CACHE PATH "gmock source directory")
set (GTEST_INCLUDE_DIR "${GMOCK_SOURCE_DIR}/gtest/include" CACHE PATH "gtest source include directory")

add_subdirectory(${GMOCK_SOURCE_DIR} "${CMAKE_CURRENT_BINARY_DIR}/gmock")

macro(LOCATION_SERVICE_ADD_TEST test_name src)
  add_executable(
    ${test_name}
    ${src})

  target_link_libraries(
    ${test_name}

    ubuntu-location-service
    ubuntu-location-service-connectivity
    ubuntu-location-service-provider-daemon
    ubuntu-location-service-daemon

    mongoose

    ${Boost_LIBRARIES}
    ${CMAKE_THREAD_LIBS_INIT}

    ${PROCESS_CPP_LIBRARIES}

    ${ARGN}

    gmock

    gtest
    gtest_main)

  add_test(${test_name} ${CMAKE_CURRENT_BINARY_DIR}/${test_name} --gtest_filter=*-*requires*)

  # Address android's limit on cmdline length and distill ubuntu-location-service into uls
  install(
    TARGETS ${test_name}
    DESTINATION ${CMAKE_INSTALL_BINDIR}/uls-tests
  )
endmacro(LOCATION_SERVICE_ADD_TEST)

include_directories (
  ${CMAKE_SOURCE_DIR}/src/location_service

  ${GMOCK_INCLUDE_DIR}
  ${GTEST_INCLUDE_DIR}
)

LOCATION_SERVICE_ADD_TEST(acceptance_tests acceptance_tests.cpp)
LOCATION_SERVICE_ADD_TEST(connectivity_manager_test connectivity_manager_test.cpp)
LOCATION_SERVICE_ADD_TEST(controller_test controller_test.cpp)
LOCATION_SERVICE_ADD_TEST(criteria_test criteria_test.cpp)
LOCATION_SERVICE_ADD_TEST(daemon_and_cli_tests daemon_and_cli_tests.cpp)
LOCATION_SERVICE_ADD_TEST(default_permission_manager_test default_permission_manager_test.cpp)
LOCATION_SERVICE_ADD_TEST(engine_test engine_test.cpp)
LOCATION_SERVICE_ADD_TEST(harvester_test harvester_test.cpp)
LOCATION_SERVICE_ADD_TEST(demultiplexing_reporter_test demultiplexing_reporter_test.cpp)

if (NET_CPP_FOUND)
  LOCATION_SERVICE_ADD_TEST(ichnaea_reporter_test ichnaea_reporter_test.cpp)
endif()

LOCATION_SERVICE_ADD_TEST(position_test position_test.cpp)
LOCATION_SERVICE_ADD_TEST(provider_selection_policy_test provider_selection_policy_test.cpp)
LOCATION_SERVICE_ADD_TEST(provider_factory_test provider_factory_test.cpp)
LOCATION_SERVICE_ADD_TEST(provider_test provider_test.cpp)
LOCATION_SERVICE_ADD_TEST(wgs84_test wgs84_test.cpp)
LOCATION_SERVICE_ADD_TEST(trust_store_permission_manager_test trust_store_permission_manager_test.cpp)

# Provider-specific test-cases go here.
if (LOCATION_SERVICE_ENABLE_GPS_PROVIDER)
  include_directories(${CMAKE_SOURCE_DIR}/src/location_service)
  LOCATION_SERVICE_ADD_TEST(gps_provider_test gps_provider_test.cpp)
endif(LOCATION_SERVICE_ENABLE_GPS_PROVIDER)

if (LOCATION_SERVICE_ENABLE_GEOCLUE_PROVIDERS)
  add_executable(geoclue_provider_test geoclue_provider_test.cpp)
  target_link_libraries(
    geoclue_provider_test
    
    ubuntu-location-service

    ${CMAKE_THREAD_LIBS_INIT}
    ${Boost_LIBRARIES}
    ${PROCESS_CPP_LIBRARIES}

    gtest
    gtest_main
  )
  if (LOCATION_SERVICE_ENABLE_DBUS_TEST_RUNNER)
    add_test(geoclue_provider_test ${DBUS_TEST_RUNNER_EXECUTABLE} --task=${CMAKE_CURRENT_BINARY_DIR}/geoclue_provider_test)
  else (LOCATION_SERVICE_ENABLE_DBUS_TEST_RUNNER)
    add_test(geoclue_provider_test ${CMAKE_CURRENT_BINARY_DIR}/geoclue_provider_test)
  endif (LOCATION_SERVICE_ENABLE_DBUS_TEST_RUNNER)
endif (LOCATION_SERVICE_ENABLE_GEOCLUE_PROVIDERS)

LOCATION_SERVICE_ADD_TEST(remote_providerd_test remote_providerd_test.cpp)

LOCATION_SERVICE_ADD_TEST(remote_provider_test remote_provider_test.cpp)
LOCATION_SERVICE_ADD_TEST(espoo_provider_test espoo_provider_test.cpp)

=== src/location_service/com/ubuntu/location/CMakeLists.txt ===
if (NET_CPP_FOUND)
  add_definitions(-DCOM_UBUNTU_LOCATION_SERVICE_HAVE_NET_CPP=1)

  set(ICHNAEA_REPORTER_SRCS service/ichnaea_reporter.cpp)
endif()

add_subdirectory(providers)

configure_file(
  service/config.h.in ${CMAKE_CURRENT_BINARY_DIR}/service/config.h @ONLY
)

add_library(
  ubuntu-location-service SHARED

  ${UBUNTU_LOCATION_SERVICE_PUBLIC_HEADERS}

  default_provider_selection_policy.cpp
  non_selecting_provider_selection_policy.cpp

  criteria.cpp
  engine.cpp
  init_and_shutdown.cpp
  position.cpp
  provider.cpp
  provider_factory.cpp
  proxy_provider.cpp
  set_name_for_thread.cpp

  service/default_configuration.cpp
  service/default_permission_manager.cpp
  service/harvester.cpp
  service/demultiplexing_reporter.h
  service/demultiplexing_reporter.cpp
  service/trust_store_permission_manager.cpp

  service/implementation.cpp
  service/skeleton.cpp
  service/stub.cpp

  service/session/implementation.cpp
  service/session/interface.cpp
  service/session/skeleton.cpp
  service/session/stub.cpp

  providers/config.cpp

  providers/remote/provider.cpp
  providers/remote/skeleton.cpp
  providers/remote/stub.cpp

  ${ICHNAEA_REPORTER_SRCS}
)

add_library(
  ubuntu-location-service-connectivity SHARED

  set_name_for_thread.cpp

  connectivity/cached_radio_cell.cpp
  connectivity/cached_wireless_network.cpp
  connectivity/manager.cpp
  connectivity/radio_cell.cpp
  connectivity/wireless_network.cpp

  connectivity/ofono_nm_connectivity_manager.cpp
)

set(symbol_map "${CMAKE_SOURCE_DIR}/symbols.map")

set_target_properties(
  ubuntu-location-service

  PROPERTIES
  LINK_FLAGS "${ldflags} -Wl,--version-script,${symbol_map}"
  LINK_DEPENDS ${symbol_map}
  VERSION ${UBUNTU_LOCATION_SERVICE_VERSION_MAJOR}.${UBUNTU_LOCATION_SERVICE_VERSION_MINOR}.${UBUNTU_LOCATION_SERVICE_VERSION_PATCH}
  SOVERSION ${UBUNTU_LOCATION_SERVICE_VERSION_MAJOR}
)

set_target_properties(
  ubuntu-location-service-connectivity

  PROPERTIES
  LINK_FLAGS "${ldflags} -Wl,--version-script,${symbol_map}"
  LINK_DEPENDS ${symbol_map}
  VERSION ${UBUNTU_LOCATION_SERVICE_VERSION_MAJOR}.${UBUNTU_LOCATION_SERVICE_VERSION_MINOR}.${UBUNTU_LOCATION_SERVICE_VERSION_PATCH}
  SOVERSION ${UBUNTU_LOCATION_SERVICE_VERSION_MAJOR}
)

add_definitions(${ENABLED_PROVIDER_TARGETS_DEFINITIONS})

target_link_libraries(
  ubuntu-location-service-connectivity

  ${CMAKE_THREAD_LIBS_INIT}
  ${Boost_LIBRARIES}
  ${DBUS_LIBRARIES}
  ${DBUS_CPP_LDFLAGS}
  ${PROCESS_CPP_LDFLAGS}
  ${GLog_LIBRARY}
  ${GFlags_LIBRARY}
)

target_link_libraries(
  ubuntu-location-service

  ubuntu-location-service-connectivity

  ${ENABLED_PROVIDER_TARGETS}

  ${CMAKE_THREAD_LIBS_INIT}
  ${Boost_LIBRARIES}
  ${DBUS_LIBRARIES}
  ${DBUS_CPP_LDFLAGS}
  ${JSON_C_LDFLAGS}
  ${LIBAPPARMOR_LDFLAGS}
  ${NET_CPP_LDFLAGS}
  ${TRUST_STORE_LDFLAGS}
  ${GLog_LIBRARY}
  ${GFlags_LIBRARY}
)

install(
  TARGETS ubuntu-location-service
  DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

install(
  TARGETS ubuntu-location-service-connectivity
  DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

add_library(
  ubuntu-location-service-provider-daemon

  service/provider_daemon.cpp
)

add_library(
  ubuntu-location-service-daemon

  service/daemon.cpp
)

add_executable(
  ubuntu-location-service-providerd

  service/provider_daemon_main.cpp
)

add_executable(
  ubuntu-location-serviced

  service/daemon_main.cpp
)

add_executable(
  ubuntu-location-serviced-cli

  service/daemon_cli_main.cpp
)

target_link_libraries(
  ubuntu-location-service-provider-daemon

  ubuntu-location-service
)

target_link_libraries(
  ubuntu-location-service-daemon

  ubuntu-location-service
)

target_link_libraries(
  ubuntu-location-service-providerd

  ubuntu-location-service-provider-daemon

  ${ENABLED_PROVIDER_TARGETS}

  ${Boost_LIBRARIES}
  ${DBUS_LIBRARIES}
  ${DBUS_CPP_LIBRARIES}
  ${GLog_LIBRARY}
  ${GFlags_LIBRARY}
)

target_link_libraries(
  ubuntu-location-serviced

  ubuntu-location-service-daemon

  ${ENABLED_PROVIDER_TARGETS}

  ${Boost_LIBRARIES}
  ${DBUS_LIBRARIES}
  ${DBUS_CPP_LIBRARIES}
  ${GLog_LIBRARY}
  ${GFlags_LIBRARY}
)

target_link_libraries(
  ubuntu-location-serviced-cli

  ubuntu-location-service-daemon

  ${ENABLED_PROVIDER_TARGETS}

  ${Boost_LIBRARIES}
  ${DBUS_LIBRARIES}
  ${DBUS_CPP_LIBRARIES}
  ${GLog_LIBRARY}
  ${GFlags_LIBRARY}
)

install(
  TARGETS ubuntu-location-service-providerd
  DESTINATION ${CMAKE_INSTALL_BINDIR}
)

install(
  TARGETS ubuntu-location-serviced
  DESTINATION ${CMAKE_INSTALL_BINDIR}
)

install(
  TARGETS ubuntu-location-serviced-cli
  DESTINATION ${CMAKE_INSTALL_BINDIR}
)

=== src/location_service/com/ubuntu/location/providers/gps/CMakeLists.txt ===
--- 
+++ 
@@ -13,7 +13,19 @@
   if (UBUNTU_HARDWARE_GPS_H)
     message(STATUS "Enabling GPS location provider")
 
-    add_library(gps provider.cpp)
+    add_library(
+        gps
+
+        gps.conf
+
+        android_hardware_abstraction_layer.h
+        android_hardware_abstraction_layer.cpp
+
+        hardware_abstraction_layer.h
+        # hardware_abstraction_layer.cpp
+
+        provider.h
+        provider.cpp)
 
     target_link_libraries(gps ubuntu_platform_hardware_api.so)
   
@@ -27,5 +39,7 @@
       -DCOM_UBUNTU_LOCATION_SERVICE_PROVIDERS_GPS ${ENABLED_PROVIDER_TARGETS_DEFINITIONS}
       PARENT_SCOPE
     )
+
+    install(FILES gps.conf DESTINATION /etc/)
   endif (UBUNTU_HARDWARE_GPS_H)
 endif (LOCATION_SERVICE_ENABLE_GPS_PROVIDER)

=== debian/changelog ===
location-service (2.1+15.04.20141110.1-0ubuntu1) vivid; urgency=low

  [ thomas-voss ]
  * Make sure that devices being added/removed by NetworkManager are
    handled correctly. (LP: #1390490)

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Mon, 10 Nov 2014 20:30:56 +0000

location-service (2.1+15.04.20141105.1-0ubuntu1) vivid; urgency=low

  [ CI bot ]
  * Resync trunk

  [ Kevin DuBois ]
  * The headers shipped in libubuntu-location-service-dev contain
    includes that are provided in the libboost-dev package (specifically
    headers like boost/units/cmath.hpp). Make the dev package depend on
    libboost-dev so the downstreams get what they need to compile
    against the libubuntu-location-service-dev headers

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Wed, 05 Nov 2014 15:51:16 +0000

location-service (2.1+15.04.20141104-0ubuntu1) vivid; urgency=low

  * New rebuild forced

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Tue, 04 Nov 2014 06:20:45 +0000

location-service (2.1+14.10.20141030~rtm-0ubuntu1) 14.09; urgency=low

  [ thomas-voss ]
  * Bump build dependency.
  * Disconnect event connections for bag of providers. (LP: #1387572)

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Thu, 30 Oct 2014 14:33:22 +0000

location-service (2.1+14.10.20141023-0ubuntu1) utopic; urgency=low

  [ thomas-voss ]
  * Prevent multiple invocations of start positioning on android GPS HAL
    to prevent buggy HAL implementations from blocking. Allow for
    decorated provider names to enable moving providers OOP. (LP:
    #1382501)

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Thu, 23 Oct 2014 16:41:05 +0000
